{
       (    +  )
      bad block
       
         :
          
        
         
       
        
}

uses dos;

{ $define i140}
{$define i800}
const
  AllImgLo	=  0;
  AllImgHi	= 49;
  {$ifdef i140}
    AllTr	= 35;
    AllSc	= 16;
  {$endif}
  {$ifdef i800}
    AllTr	= 160;
    AllSc	= 21;
  {$endif}
  AllBl		= AllTr * AllSc - 1;

type
  tSector	= Array[0..63] of Cardinal;
  tImgFile	= Array[0..AllBl] of tSector;
  tImgNumber	= AllImgLo..AllImgHi;
  tDistDesc	= Record
      p		: Boolean;			//  
      d		: LongInt;			//    
      n		: tImgNumber;			//  
    end;

  tImgDesc	= Record
    present	: Boolean;				//  
    data	: tImgFile;				//  
    datavalid	: Array[0..AllBl] of Boolean;		//    
    distance	: Array[tImgNumber] of tDistDesc;	//     
    name	: String;				//  
  end;

var
  Images	: Array[AllImgLo..AllImgHi] of tImgDesc;


//      "N [t/s]"
function sector_n2s(const s: LongInt): String;
var l: String;
begin
  str(s, sector_n2s);	sector_n2s := sector_n2s + ' [';
  str(s div AllSc, l);	sector_n2s := sector_n2s + l + '/';
  str(s mod AllSc, l);	sector_n2s := sector_n2s + l + ']';
end;


//    ,  
// present, data, datavalid, name
procedure addimage(const imgnum: tImgNumber; const n: String);
var f: File of tImgFile; is_ok: Boolean; s, o, bb: LongInt;
begin With Images[imgnum] do begin
  bb := 0;
  assign(f, n); reset(f); read(f, data); close(f);
  for s := 0 to AllBl do begin
    is_ok := False;
    for o := 0 to 63 do if data[s][o] <> $BDBDBDBD then begin is_ok := True; break end;
    datavalid[s] := is_ok;
    if is_ok then else inc(bb);
  end;
  present := True;
  name := n;
  WriteLn('Add ', n, ' image, ', bb, ' bad block(s)');
end end;


//   ,  ,     addimage
procedure reading;
var SR: SearchRec; n: tImgNumber;
begin
  WriteLn;
  WriteLn('>>> Find and loading images...');
  for n := AllImgLo to AllImgHi do Images[n].present := False;

  n := AllImgLo;
{$ifdef UNIX}
  FindFirst('*', $EF, SR);
{$else}
  FindFirst('*.*', 0, SR);
{$endif}
  While DosError = 0 do begin
    if (SR.size >= SizeOf(tImgFile)) and (SR.size <= SizeOf(tImgFile) + 128) then begin
      addimage(n, SR.name);
      inc(n);
    end else WriteLn(SR.name, ' [', HexStr(SR.attr, 4), '] is not image');
    FindNext(SR);
  end;
  FindClose(SR);
end;


//        ,   
//         bad-
procedure unmarkequ;
var i1, i2: tImgNumber; s, o: LongInt; equ: Boolean;
begin
  WriteLn;
  WriteLn('>>> Compare and delete images...');
  for i1 := AllImgLo to AllImgHi do With Images[i1] do if present then begin
    Write(i1: 2, ': ', name, ' -');
    for i2 := i1 to AllImgHi do if Images[i2].present and (i1 <> i2) then begin
      Write(i2: 3); equ := True;
      for s := 0 to AllBl do begin
        if datavalid[s] <> Images[i2].datavalid[s] then equ := False else
	  if datavalid[s] then for o := 0 to 63 do if data[s][o] <> Images[i2].data[s][o] then equ := False;
	if not equ then break;
      end;
      if equ then begin
        Write('d');
	Images[i2].present := False;
      end;
    end;
    WriteLn;
  end;
end;


//        im
procedure sortdistance(const im: tImgNumber);

  // cmp := d1 < d2
  function cmp(const d1, d2: tDistDesc): Boolean;
  begin
    if d1.p = d2.p then begin
      if d1.p then cmp := d1.d < d2.d else cmp := False;
    end else cmp := d1.p;
//    if d1.p and d2.p then cmp := d1.d < d2.d else cmp := False; 
  end;

  Procedure Sort(l, r: tImgNumber);
  Var i, j: AllImgLo-1..AllImgHi+1; x, y: tDistDesc;
  Begin With Images[im] do Begin
    i := l; j := r; x := distance[(l+r) DIV 2];
    Repeat
      while cmp(distance[i], x) do i := i + 1;
      while cmp(x, distance[j]) do j := j - 1;
      If i <= j then
      Begin
	y := distance[i]; distance[i] := distance[j]; distance[j] := y;
//	WriteLn(i:10, j:10);
	i := i + 1; j := j - 1;
      End;
    Until i > j;
    If l < j then Sort(l, j);
    If i < r then Sort(i, r);
  End End;

begin
  Sort(AllImgLo, AllImgHi);
end;


//       ,     
//    sortdistance       
procedure calcdistance;
var i1, i2: tImgNumber; s, o, d: LongInt; diff: Boolean;
begin
  WriteLn;
  WriteLn('>>> Calc and sort distance...');
  for i1 := AllImgLo to AllImgHi do With Images[i1] do if present then begin
    Write(i1: 2, ': ', name, ' -');
    for i2 := AllImgLo to AllImgHi do if Images[i2].present and (i1 <> i2) then begin
      Write(i2: 3); d := 0;
      for s := 0 to AllBl do begin
        diff := False;
        if datavalid[s] <> Images[i2].datavalid[s] then diff := True else
	  if datavalid[s] then for o := 0 to 63 do if data[s][o] <> Images[i2].data[s][o] then begin diff := True; Break; end;
	if diff then inc(d);
      end;
      Write(':', d);
      distance[i2].p := True;
      distance[i2].d := d;
      distance[i2].n := i2;
    end else distance[i2].p := False;
    WriteLn;
    SortDistance(i1);
    Write('  [');
    for i2 := AllImgLo to AllImgHi do With distance[i2] do if p then Write(i2, '.', n, ':', d, ' ');
    WriteLn(']');
  end;
end;


//        
function cureblocks: LongInt;
label 1;
var acc_i, im, don_i: tImgNumber; s: LongInt;
begin
  WriteLn;
  WriteLn('>>> Cure images...'); cureblocks := 0;
  for acc_i := AllImgLo to AllImgHi do With Images[acc_i] do if present then begin
    WriteLn('===== ', acc_i: 2, ': ', name, ' =====');
    for s := 0 to AllBl do if not datavalid[s] then begin
      for im := AllImgLo to AllImgHi do if distance[im].p then begin
        don_i := distance[im].n;
	if Images[don_i].datavalid[s] then begin
	  WriteLn('Sector ', sector_n2s(s), ' cured from ', Images[don_i].name, ', distance = ', distance[im].d);
  	  data[s] := Images[don_i].data[s];
	  datavalid[s] := True;
	  inc(cureblocks);
	  goto 1;
	end;
      end;
      WriteLn('Donor for sector ', sector_n2s(s), ' not found :(');
      1:
    end;
  end;
end;


//   
//      ,    
procedure showdifferent;
label 1;
var i, s, ic, o: LongInt; anyoutpresent: Boolean;
begin
  WriteLn;
  WriteLn('>>> Show diff...');

  Write(#9);
  for i := AllImgLo to AllImgHi do With Images[i] do if present then Write(#9, i, ':', name);
  WriteLn;

  for s := 0 to AllBl do begin

    for i := AllImgLo to AllImgHi do With Images[i] do if present then
      for ic := AllImgLo to AllImgHi do if Images[ic].present and (i <> ic) then
        for o := 0 to 63 do if data[s][o] <> Images[ic].data[s][o] then goto 1;
    continue;

    1:
    Write(sector_n2s(s), #9);
    
    for i := AllImgLo to AllImgHi do With Images[i] do if present then begin

      anyoutpresent := False;
      for ic := AllImgLo to AllImgHi do if Images[ic].present and (i <> ic) then begin

        for o := 0 to 63 do if data[s][o] <> Images[ic].data[s][o] then begin
	  if anyoutpresent then Write(',');
	  Write(ic);
	  anyoutpresent := True;
	  break;
	end;

      end;
      if anyoutpresent then else Write('-');
      Write(#9#9);

    end;

    WriteLn;
    
  end;
end;


//  ,   
procedure writing;
var n: tImgNumber; f: File of tImgFile;
begin
  WriteLn;
  WriteLn('>>> Writing images...');
  for n := AllImgLo to AllImgHi do With Images[n] do if present then begin
    WriteLn(name + '.rep saved');
    assign(f, name + '.rep'); rewrite(f); Write(f, data); close(f);
  end;
end;


begin
  reading;	//  ,     
  unmarkequ;	//   
  calcdistance;	//    ,   
  while cureblocks <> 0 do ;	//        
  unmarkequ;	// ݣ    
  showdifferent;//   
  writing;	//        
end.
